<?php
/**
 * @version		$Id: gradesubmission.php,v 1.18 2010-10-18 18:00:21 juanca Exp $
 * @package		vpl. grade submission
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
global $CFG, $USER;
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/grade_form.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';

$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
$course = $vpl->get_course();
$instance = $vpl->get_instance();
$userid = required_param('userid',PARAM_INT);
$inpopup = optional_param('inpopup',0,PARAM_INT);
$vpl->require_capability(VPL_GRADE_CAPABILITY);
//Read records
$submissionid =  optional_param('submissionid',FALSE,PARAM_INT);
if($submissionid){
	$subinstance = get_record('vpl_submissions','id',$submissionid);
}else{
	$subinstance = $vpl->last_user_submission($userid);
}
//Print header
$CFG->stylesheets[] = vpl_mod_href('views/sh.css');
if($inpopup){
	$vpl->print_header_simple('onload="resizeSView();"');
}else{
	$vpl->print_header(get_string('grade'),false,'onload="resizeSView();"');
	$vpl->print_view_tabs(basename(__FILE__));
}

//Check consistence
if(!$subinstance){
	notice(get_string('nosubmission',VPL),vpl_mod_href('view.php','id',$id,'userid',$userid));
}
$submissionid = $subinstance->id;

if($subinstance->userid != $userid){
	print_error('vpl submission user inconsistence');
}
if($vpl->get_instance()->id != $subinstance->vpl){
	print_error('vpl submission vpl inconsistence');
}
$submission = new mod_vpl_submission($vpl,$subinstance);

$link = vpl_mod_href('forms/gradesubmission.php','id',$id,'userid',$userid);
$linkrel = vpl_rel_url('forms/gradesubmission.php','id',$id,'userid',$userid);

//no marked or marked by current user
if($subinstance->dategraded== 0 || $subinstance->grader == $USER->id){
	if($inpopup){
		$href=vpl_rel_url('gradesubmission.php','inpopup',1);
	}else{
		$href='gradesubmission.php';
	}
	$grade_form = new mod_vpl_grade_form($href,$vpl);
	if ($grade_form->is_cancelled()){ //Grading canceled
		redirect($link);
	} else if ($fromform=$grade_form->get_data()){ //Grade (new or update)
		if(isset($fromform->evaluate)){
			//TODO evaluate any submission
			$inpopup = optional_param('inpopup',0,PARAM_INT);
			$url=vpl_mod_href('forms/evaluation.php','id',
			         $fromform->id,'userid',$fromform->userid,'grading',1,'inpopup',$inpopup);
			vpl_inmediate_redirect($url);
		}
		if(isset($fromform->removegrade)){
			if($submission->remove_grade()){
				$vpl->add_to_log('remove grade',$linkrel);
				if($inpopup){
					//Change grade info at parent window
					echo vpl_include_jsfile('updatesublist.js',false);	
					$jscript ='vpl_updatesublist('.$submission->get_instance()->id.',';
					$jscript.="' ',' ',' ');";
					echo vpl_include_js($jscript,false);
				}
				vpl_redirect(get_string('graderemoved',VPL),$link,5);
			}else{
				vpl_redirect(get_string('gradenotremoved',VPL),$link,5);
			}
		}
		if(!isset($fromform->grade) && !isset($fromform->savenext)){
			print_error('badinput');
			die;
		}
		
		if($submission->is_graded()){
			$action = 'update grade';
		}else{
			$action = 'grade';
		}
		//Remove slashes added by form
		$fromform = stripslashes_safe($fromform);
		//Build log info
		$log_info='grade: '.$fromform->grade;
		foreach($fromform as $key => $value){
			if(strpos($key,'outcome_grade')===0){
				$on= substr($key,strlen('outcome_grade_'));
				$log_info .= ' o'.$on.' '.$value;
			}
		}
		$vpl->add_to_log($action,$linkrel,$log_info);
		if(!$submission->set_grade($fromform)){
			vpl_redirect(get_string('gradenotsaved',VPL),$link,5);
		}
		if($inpopup){
			//Change grade info at parent window
			echo vpl_include_jsfile('updatesublist.js',false);
			$text = $submission->print_grade_core();
			$grader = fullname($submission->get_grader($USER->id)); 
	    	$gradedon = userdate($submission->get_instance()->dategraded);
			
			$jscript ='vpl_updatesublist('.$submission->get_instance()->id.',';
			$jscript.='\''.addslashes($text).'\',';
			$jscript.='\''.addslashes($grader).'\',';
			$jscript.='\''.addslashes($gradedon).'\');';
			echo vpl_include_js($jscript,false);
			if(isset($fromform->savenext)){
				$url=$CFG->wwwroot.'/mod/vpl/forms/gradesubmission.php?id='.$id.'&inpopup=1&userid=';
				$jscript ='vpl_go_next(\''.$submission->get_instance()->id.'\',\''.addslashes($url).'\');';
				echo vpl_include_js($jscript,false);
			}
			close_window();
		}else{
			vpl_redirect(get_string('graded',VPL),$link,2);
		}
	} else {
		//Show grade form
		$vpl->add_to_log('view grade',$linkrel,'grade: '.$subinstance->grade);
		$data = new stdClass();
		$data->id = $vpl->get_course_module()->id;
		$data->userid = $subinstance->userid;
		$data->submissionid = $submissionid;
		if($submission->is_graded()){
			//format number removing trailing zeros
			$data->grade = rtrim(rtrim($subinstance->grade,'0'),'.,');
			$data->comments = $submission->get_grade_comments();
		}else{
			$res=$submission->getCE();
			if($res['executed']){
				$data->grade = $submission->proposedGrade($res['execution']);
				$data->comments = $submission->proposedComment($res['execution']);;
			}
		}
		if(!empty($CFG->enableoutcomes)){
			$grading_info = grade_get_grades($vpl->get_course()->id, 'mod', 'vpl',
					$vpl->get_instance()->id, $userid);
			if (!empty($grading_info->outcomes)) {
			 	foreach($grading_info->outcomes as $oid=>$outcome) {
			 		$field='outcome_grade_'.$oid;
			 		$data->$field=$outcome->grades[$userid]->grade;
			 	}
			 }
		}
		
		$grade_form->set_data($data);
		echo '<div style="height:210px; width:1050px; overflow:auto;">';
		echo '<div style="float:left;width:600px;">';
		$grade_form->display();
		echo '</div>';
		$comments=$vpl->get_grading_help();
		if($comments>''){
			echo '<div style="float:left;width:400px;">';
			print_box_start();
			echo '<b>'.get_string('listofcomments',VPL).'</b><hr />';
			echo $comments;
			print_box_end();
		}
		echo '</div>';
		echo '</div>';
		echo '<hr />';
		echo '<div id="submission_view" style="height:400px; overflow:auto;" >';
		$vpl->print_variation( $subinstance->userid);
		$submission->print_submission();
		echo '</div>';
		echo vpl_include_jsfile('updatesublist.js');
		echo vpl_include_js('vpl_hlrow('.$submissionid.')');
		echo vpl_include_js('window.onunload= function(){vpl_unhlrow('.$submissionid.');}');
	}
}else{
	vpl_inmediate_redirect(vpl_mod_href('forms/submissionview.php','id',$id,'userid',$userid));	
}
echo vpl_include_jsfile('grade.js');
$vpl->print_footer_simple();

?>