/**
 * @version		$Id: updatesublist.js,v 1.3 2010/01/19 17:56:31 juanca Exp $
 * @package		vpl. jscript functions to update submission list grade
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

/**
 * Highlight row
 * @param subid submission identification 
*/ 
function vpl_hlrow(subid){
	if(opener == null){
		return;
	}
	var ssubid=new String(subid);
	var divgrade= opener.document.getElementById('g'+ssubid);
	var divgrader= opener.document.getElementById('m'+ssubid);
	var divgradeon= opener.document.getElementById('o'+ssubid);
	if(divgrade){
		divgrade.style.backgroundColor='yellow';
		divgrade.style.color='black';
	}
	if(divgrader){
		divgrader.style.backgroundColor='yellow';
		divgrader.style.color='black';
	}
	if(divgradeon){
		divgradeon.style.backgroundColor='yellow';
		divgradeon.style.color='black';
	}
}

/**
 * Unhighlight row
 * @param subid submission identification 
*/ 
function vpl_unhlrow(subid){
	if(opener == null){
		return;
	}
	var ssubid=new String(subid);
	var divgrade= opener.document.getElementById('g'+ssubid);
	var divgrader= opener.document.getElementById('m'+ssubid);
	var divgradeon= opener.document.getElementById('o'+ssubid);
	if(divgrade){
		divgrade.style.backgroundColor='';
		divgrade.style.color='';
	}
	if(divgrader){
		divgrader.style.backgroundColor='';
		divgrader.style.color='';
	}
	if(divgradeon){
		divgradeon.style.backgroundColor='';
		divgradeon.style.color='';
	}
}

/**
 * Update submission list grade
 * @param subid submission identification 
*/ 
function vpl_updatesublist(subid,grade,grader,gradeon){
	if(opener == null){
		return;
	}
	var ssubid=new String(subid);
	var divgrade= opener.document.getElementById('g'+ssubid);
	var divgrader= opener.document.getElementById('m'+ssubid);
	var divgradeon= opener.document.getElementById('o'+ssubid);
	if(divgrade){
		divgrade.innerHTML=grade;
		divgrade.style.backgroundColor='';
		divgrade.style.color='';
	}
	if(divgrader){
		divgrader.innerHTML=grader;
		divgrader.style.backgroundColor='';
		divgrader.style.color='';
	}
	if(divgradeon){
		divgradeon.innerHTML=gradeon;
		divgradeon.style.backgroundColor='';
		divgradeon.style.color='';
	}
}

/**
 * Go to next submission
 * @param subid submission id
 * @param url base of next
*/ 
function vpl_go_next(subid,url){
	if(opener == null){
		return;
	}
	var ssubid=new String(subid);
	var divnext= opener.document.getElementById('n'+ssubid);
	if(divnext){
		location.replace(url+divnext.innerHTML);
	}
}
