<?php
/**
 * Unit tests for mod/vpl/views/statics.php.
 *
 * @version		$Id: testvplstatistics.php,v 1.1 2010/05/14 17:58:58 juanca Exp $
 * @package		vpl. Unit tests for mod/vpl/views/statics.php
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino jcrodriguez@dis.ulpgc.es
 **/

if (!defined('MOODLE_INTERNAL')) {
	die('Direct access to this script is forbidden.');
}

require_once($CFG->dirroot.'/mod/vpl/views/statistics.class.php');

class vpl_statics_test extends UnitTestCase {
	function test_all(){
		$data = array(array(),array(3,2,1,0,1,2,3),array(4,5,3,4),array(1,1,1));
		$res_total = array(0,12,16,3);
		$res_items = array(0,7,4,3);
		$res_mean = array(0,12/7,16/4,3/3);
		$res_deviation = array();
		$i=0;
		foreach($data as $serie){
			$mean = $res_mean[$i];
			$sum2 = 0;
			foreach($serie as $value){
				$sum2 += ($mean-$value)*($mean-$value);
			}
			if($res_items[$i]>0){
				$res_deviation[] = sqrt($sum2/$res_items[$i]);
			}else{
				$res_deviation[] = 0;
			}
			$i++;
		}
		$i=0;
		foreach($data as $serie){
			$object = new vpl_statistics();
			foreach($serie as $value){
				$object->count_item();
				for($j=0; $j < $value; $j++){
					$object->count();
				}
				$object->end_count();
			}
			$this->assertEqual($object->get_items(),$res_items[$i]);
			$this->assertEqual($object->get_total(),$res_total[$i]);
			$this->assertEqual($object->get_mean(),$res_mean[$i]);
			$this->assertWithinMargin($object->get_deviation(),$res_deviation[$i],0.001);
			$i++;
		}
	}
}

?>
