<?php 
/**
 * @version		$Id: previoussubmissionslist.php,v 1.4 2010/05/10 11:39:00 juanca Exp $
 * @package		vpl. List previous submissions for a vpl and user
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';
$id = required_param('id', PARAM_INT);
$userid = required_param('userid', PARAM_INT);
$vpl = new mod_vpl($id);
$course = $vpl->get_course();
$vpl->require_capability(VPL_GRADE_CAPABILITY);
$vpl->add_to_log('view previous', vpl_rel_url('previoussubmissionslist.php','id',$id,'userid',$userid));
//Load strings
$strdatesubmitted		= get_string('datesubmitted',VPL);
$strdescription			= get_string('description',VPL);
//Print header
$vpl->print_header(get_string('previoussubmissionslist',VPL));
$vpl->print_view_tabs(basename(__FILE__));
//TODO list users
$timenow = time();
$table->head  = array ('#',$strdatesubmitted, $strdescription);
$table->align = array ('rigth','left', 'rigth');
$table->nowrap = array (true,true,true);
$submissionslist = $vpl->user_submissions($userid);
if($submissionslist){
	$nsub = count($submissionslist);
	foreach ($submissionslist as $submission) {
		$link = vpl_mod_href('forms/submissionview.php','id',$id,'userid',$userid,'submissionid',$submission->id);
		$date = '<a href="'.$link.'">'.userdate($submission->datesubmitted).'</a>';
		$sub = new mod_vpl_submission($vpl,$submission);
		$table->data[] = array ($nsub--,
								$date,
								s($sub->get_detail()));
	}
}
echo "<br />";
print_table($table);
$vpl->print_footer();

?>